/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore.Arrows;

import CatCore.ConformanceError;
import CatCore.ExecutionError;
import CatCore.Main;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author dsb AorP = arrow or path
 */
public abstract class AorP implements Arw, java.io.Serializable {
    // below is the "table" of all arrows, domains, or paths

    private static HashMap<String, AorP> dictionary = new HashMap<>();

    // for state stacks
    public static HashMap<String, AorP> getContents() {
        return dictionary;
    }

    public static void putContents(HashMap<String, AorP> x) {
        dictionary = x;
    }
    
    // standard methods for dictionary

    public static AorP get(String name) {
        return dictionary.get(name);
    }

    public static void init() {
        dictionary = new HashMap<>();
    }

    public static AorP enter(String name, AorP me) {
        AorP x = dictionary.get(name);
        if (x == null) {
            dictionary.put(name, me);
            return me;
        }
        Main.error("duplicate domain, arrow, or path name: " + name);
        return null;
    }

    public static void validateAll(PrintStream ps) {
        for (AorP i : dictionary.values()) {
            i.validate(ps);
        }
    }
    
    public static int size() {
        return dictionary.size();
    }

    // for debugging
    public static void dump() {
        System.out.println("Dump of ADoP dictionary contents");
        for (Map.Entry<String, AorP> c : dictionary.entrySet()) {
            System.out.println(c.getKey() + " " + c.getValue());
        }
        System.out.println();
    }

    // append file of CTO to ps
    protected static void addOn(String filename, PrintStream ps) {
        try {
            ps.format("/*----------%s----------*/\n\n",filename);
            BufferedReader br = new BufferedReader(new FileReader(filename));
            while (true) {
                String line = br.readLine();
                if (line == null) {
                    break;
                }
                ps.format("%s\n", line);
            }
        } catch (IOException e) {
            Main.error("file not found: " + filename);
        }
    }

    // ---------------- instance AorP methods ------------------
    public abstract String name();

    public abstract void execute() throws ExecutionError, ConformanceError;

    public abstract String toString();

    public abstract void validate(PrintStream ps);
    
    public abstract void startComputingIOArray();
    
    // for GUI consumption
    protected void clearSchemaAndConform() {
        CatGui.MainGui.targetSchema = null;     // no idea what kind of file is produce
        CatGui.MainGui.targetConform = null;    // it doesn't have a schema or a prolog conform file
    }

    public abstract void finishComputingIOArray();
}
