/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore.Arrows;

import CatCore.CTO;
import CatCore.ConformanceError;
import CatCore.Domains.Domain;
import CatCore.ExecutionError;
import CatCore.Var;

/**
 *
 * @author dsb
 */
public class ArrowMove extends Arrow {
    
    public ArrowMove(String name, String domain, String range) {
        super(name, domain, range);
        // should have the same base
       if (!Domain.getBaseName(domain).equals(Domain.getBaseName(range)))
           CatCore.Main.error("domain and range of arrow move must have the same domain base, not "+domain+">"+range);
       if (domain.equals(range))
           CatCore.Main.error("domain and range of arrow move must be different, not "+domain+">"+range );
    }
    
    @Override
    public void execute() throws ExecutionError, ConformanceError {
        CTO input = Var.get(domains[0],this);
        Domain d = Domain.get(ranges[0]);
        CTO output = new CTO(input.name(), d.dom(), d.ext());
        Var.put(ranges[0],output);
        copyfile(input.fullName(), output.fullName());
        // assume file conforms to constraints
    }
    
    // nothing special about validation -- just do what other arrows do
    
    @Override
    public void startComputingIOArray() {
        clearSchemaAndConform();
        CatGui.MainGui.arrowFile = null;
        CatGui.MainGui.io = null;
    }
}
