/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore.Arrows;

import CatCore.CTO;
import CatCore.ConformanceError;
import CatCore.ExeMethods;
import CatCore.ExecutionError;
import CatCore.Main;
import CatCore.Var;
import java.io.File;
import java.io.PrintStream;

/**
 *
 * @author dsb
 */
public class ArrowVm extends ArrowPrologUtilities {

    // A vm2t arrow maps 1+ prolog files into a single file
    // the name of the output file is derived from the CTO of the first input (domain[0]) and the
    // ranges[0] information

    
    String vmTemplateFile;

    public ArrowVm(String name, String domainName, String rangeName, String vmTemplateFile) {
        // Step 1: declare arrow itself and the 'executable' vm template
        super(name, domainName, rangeName);
        this.vmTemplateFile = vmTemplateFile;

//       // now check to ensure that there is only one input & one output domain 
//       // this is required by vm2t -- it produces only one output file
//       if (domains.length!=1)
//           MainGui.error("too many input domains for vm2t arrow "+name);
//       if (ranges.length!=1)
//           MainGui.error("too many output domains for vm2t arrow "+name);

//        // Step 2: now check to see if the ext() of the input domain(s) are all "pl"
//        checkTypeConstraints(domains, name, "prolog", "pl", "input");
    }

    @Override
    public void execute() throws ExecutionError, ConformanceError {
        File v, n;

        // Step 1: get a single prolog input file
        CTO in = getInputCTO(this);

        // Step 2: get the output CTO

        CTO out = getOutputCTO(this);

        // Step 3: now execute vm2t
        try {
            // Step 3a: create command line (prolog-file template-file) then execute vm2t
            
            // old way to invoke is through java directly
            //  String[] args = {in.fullName(), HomePath.METAMODEL_PATH + "libvm/" + vmTemplateFile};
            //CatCore.vm2t.MainGui.main(args);
            
            // new way is through execution
            String[] args = {Main.JAVA_EXE, 
                             "CatCore.vm2t.Main", 
                             in.fullName(), 
                             Main.METAMODEL_PATH + "libvm/" + vmTemplateFile,
                             out.fullName()};
            ExeMethods.executeCatCmdLine(args);
                    

// HENCEFORTH ASSUME THAT VELOCITY OUTPUTS TO THE CORRECT NAME
        } catch (ExecutionError | ConformanceError e) {
            Main.error(e);
        }

        // Step 4: Enter the newly created file into Var and check for conformance
        Var.put(out);
        out.conform();
    }
    
    // ensure that there is a vm file to read
    @Override
    public void validate(PrintStream ps) {
        super.validate(ps);
        String fileName = Main.METAMODEL_PATH + "libvm/" + vmTemplateFile;
        File f = new File(fileName);
        if (!f.exists())
            ps.println("cannot find vm file "+fileName);
    }
    
    @Override
    public void startComputingIOArray() {
        setSchemaAndConform();
        CatGui.MainGui.arrowFile = CatCore.Main.METAMODEL_PATH + "libvm/" + vmTemplateFile;
        computePartialIoArray();
    }
        
}