/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore.Arrows;

import CatCore.Main;

/**
 *
 * @author dsb
 */
public class PathParse {

    private String toParse;

    public PathParse(String toParse) {
        this.toParse = toParse;
    }

    // a path declaration looks like:    pathname = adp . adp . adp . ... . ;
    // parse parses this into a ArrowPath(pathname, adp[]) declaration
    public ArrowPath parse() {
        String[] pair;

        // Step 1: split the string into (pathname, path) parts
        pair = toParse.split("=");
        if (pair.length != 2) {
            Main.error("illegal path declaration: " + toParse);
        }

        // Step 2: now parse the path string into a path array
        String name = pair[0].trim();
        return new ArrowPath(name, pair[1]);
    }

    // line is of the form adp . adp . ... . adp ;
    // where a = arrow name
    //       d = domain>domain (move an object to subscripted domains)
    //       d = domain+string (to rename the current object)
    //       p = path name
    
    public static String[] parseBody(String line) {
        // Step 1: last character of line must be ';'
        line = line.trim();
        if (!line.endsWith(";")) {
            Main.error("path does not end in ';' : " + line);
        }
        line = line.substring(0, line.length() - 1);
        
        return partition(line);
    }
    
    public static String[] partition(String line) {

        // Step 1: now partition -- cannot have empty ("") partitions
        String[] result;
        result = line.split("\\.");
        for (int i = 0; i < result.length; i++) {
            if (result[i].equals("")) {
                Main.error("empty .. path in " + line);
            }
            result[i] = result[i].trim();
        }
        return result;
    }

    @Override
    public String toString() {
        return toParse;
    }
}
