package CatCore;

import java.io.File;

public class CleanAll {

    static String deleteList[] = {"script.txt", "error.txt", "conformance.txt", "executedLine.bat", "Kon.X.pl", "Exe.X.pl", "out.txt",
        "sortedCor.txt", "sortedOut.txt"};

    public static void main(String... args) {
        Clean.main((String[]) null);
        deleteAllNonSaveFiles();
    }

    static String AlwaysSaveList[] = {"libpl", "libvm", "cat.lite", "cat.state", "config.properties", ".jar"};
    static String AppSaveList[];

    static void deleteAllNonSaveFiles() {
        boolean delete;
        String filename;

        Main.readConfigFile();

        // Step 1: get Application save list
        String tmp = Main.SAVE_LIST.replace(",", " ").replace(";", " ");
        String tmpArray[] = tmp.split(" ");
        AppSaveList = concat(AlwaysSaveList, tmpArray);

        File folder = new File(".");
        File[] arrayOfFiles = folder.listFiles();
        for (File f : arrayOfFiles) {
            delete = true;
            filename = f.getName();
            for (String n : AppSaveList) {
                n = n.trim();
                if (n.equals("")) {
                    continue;
                }

                if (filename.contains(n)) {
                    delete = false;
                }
            }
            if (delete || filename.contains("~")) {
                try {
                    CatCore.vm2t.Main.recursiveDelete(f);
                } catch (Exception e) {
                    System.err.format("Could not delete file or directory %s\n", filename);
                }
            }
        }
    }

// stolen from http://www.java2s.com/Code/Java/Data-Type/Concatenatestwoarraysofstrings.htm
    public static final String[] concat(String[] s1, String[] s2) {
        String[] erg = new String[s1.length + s2.length];

        System.arraycopy(s1, 0, erg, 0, s1.length);
        System.arraycopy(s2, 0, erg, s1.length, s2.length);

        return erg;
    }
}
