/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.Map;
import javax.swing.JOptionPane;

/**
 *
 * @author dsb
 */
public class ExeMethods {
    final static String executedLine = "executedLine.bat";

    // original design of execute
    // adapted from http://www.java-tips.org/java-se-tips/java.util/from-runtime.exec-to-processbuilder.html
    public static void executeCatCmdLine(String[] cmdarray) throws ExecutionError, ConformanceError {
        String line;
        String tmp;
        String errorLine = "";
        boolean error = false;
//        boolean first;
        String command = "";
        for (int i = 0; i < cmdarray.length; i++) {
            tmp = Main.normalizePath(cmdarray[i]);
            cmdarray[i] = tmp;
            if (i == 0) {
                command = '"' + tmp + '"' + ' ';
            } else {
                command = command + tmp + " ";
            }
        }
        try {
            PrintStream eps = new PrintStream(Main.CURRENT_DIRECTORY + executedLine);
            eps.println(command);
            eps.close();
        } catch (FileNotFoundException e) {
            throw new ExecutionError("C4: cannot write " + executedLine);
        }
        if (Main.debug) {
            System.out.println("Command to Execute : " + command);
        }
        try {
            Process p = exe(cmdarray);
            CTO.currentProcessExecuting = p;
            BufferedReader er = new BufferedReader(new InputStreamReader(p.getErrorStream()));
            BufferedReader in = new BufferedReader(new InputStreamReader(p.getInputStream()));
            while ((line = er.readLine()) != null) {
                error = true;
                errorLine = errorLine + line + "\n";
            }
            while ((line = in.readLine()) != null) {
                System.out.println("Stdout : " + line);
            }
            p.waitFor();
            p.destroy();
        } catch (IOException | InterruptedException e) {
            throw new NonSilentError("C5: unable to execute arrow " + e.getMessage());
        }
        if (error) {
            PrintStream ps;
            try {
                ps = new PrintStream(Main.errorMsgFile());
            } catch (FileNotFoundException e) {
                throw new ExecutionError("C6: could not open " + Main.errorMsgFile());
            }
            ps.print(errorLine);
            ps.flush();
            ps.close();
            throw new ExecutionError("C7: Consult file: " + Main.errorMsgFile());
        }
    }

    //  execute command line
    public static Process execute(String... cmdarray) {
        try {
            return exe(cmdarray);
        } catch (IOException e) {
            JOptionPane.showMessageDialog(CatGui.Main.theGui, "cannot execute cmdarray " + makeString(cmdarray), "Fatal Error!", JOptionPane.ERROR_MESSAGE);
            System.exit(1);
            return null;  // will never reach here -- satisfies a whiny compiler
        }
    }

    // this is the core code to execute a command line
    public static Process exe(String... cmdarray) throws IOException {
        ProcessBuilder pb = new ProcessBuilder(cmdarray);
//        String cd = Main.CURRENT_DIRECTORY;
//        pb.directory(new File(cd));
        Map<String, String> env = pb.environment();
//        env.put("CLASSPATH", Main.CLASSPATH);
//        env.put("PATH", Main.PATH);
        return pb.start();
    }
    
    public static void silentExe(String... cmdarray) {
        try {
            exe(cmdarray);
        } 
        catch( IOException e ) {} 
    }

    public static String makeString(String[] cmd) {
        String out = "";
        for (String x : cmd) {
            out = out + x + " ";
        }
        return out;
    }

}
