/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CatCore;

import CatCore.Arrows.AorP;
import CatCore.Domains.Domain;
import java.io.PrintStream;

/**
 Usage: Validate (no arguments)
         examines local cat.lite.pl and checks if all executables are present
 */
public class Validate {
    
    public static void main(String... args) {
        PrintStream ps=System.err;
        
        // Step 1: initialize CatCore
        
        CatCore.Main.readConfigFile();


        // Step 4: read in the specification -- remember that
        //         this is part of bootstrapping, so we have pushed
        //         whatever the state of arrows,variables, etc. onto
        //         the stack -- when we leave, we pop it off.
        Main.readCatSpec(CatCore.Main.CURRENT_DIRECTORY+"cat.lite.pl",ps);
        
        // Step 5: we are validating a model (which is a lite metamodel).  
        // compute model home -- remove the xxx.lite.pl from args[0]
        String modelHome = CatCore.Main.CURRENT_DIRECTORY;

        // Step 5: for all pl domains, make sure that there is
        //         a conform file
        
        Domain.validateAll(ps, modelHome);

        // Step 4: validate each arrow
        AorP.validateAll(ps);

        // Step 5: flush everything and see if there is a conformation error
        ps.close();
        System.out.println("unless you saw error messages, you're OK");
    }
}
