/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CatGui;

import CatCore.Arrows.AorP;
import CatCore.Arrows.Arrow;
import CatCore.Arrows.ArrowPath;
import CatCore.Arrows.Arw;
import CatCore.CTO;
import CatCore.Domains.Domain;
import CatCore.ExeMethods;
import CatCore.Var;
import java.awt.EventQueue;
import java.io.File;
import java.io.FileInputStream;
import java.util.Arrays;
import java.util.HashMap;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author dsb
 */
public class Main extends MainGui {
    public static Main theGui;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // for debugging System.out.println( metaModelHome.getName());
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (UIManager.LookAndFeelInfo info : UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException ex) {
            System.err.println("can't execute CatGUI");
            ex.printStackTrace();
        }
        //</editor-fold>
        /* Create and display the form */
        EventQueue.invokeLater(new Runnable() {
            public void run() {
                Main theGui = new Main();
//                theGui.setTitle(metaModelHome.getName());
                theGui.setVisible(true);
                CatGui.Main.theGui = theGui;
                //new Watch(theGui).start();
            }
        });
    }

    @Override
    void initArrows() {
        HashMap<String, AorP> as = AorP.getContents();
        ListOfArrows = new String[as.size()];
        int i = 0;
        for (AorP a : as.values()) {
            if (a instanceof ArrowPath) {
                ArrowPath ap = (ArrowPath) a;
                ListOfArrows[i++] = ap.name() + " = " + ap.path();
            } else {
                ListOfArrows[i++] = a.name();
            }
        }
        Arrays.sort(ListOfArrows);
    }

    @Override
    void initTable() {
        HashMap<String, Domain> ds = Domain.getContents();
        HashMap<String, CTO> var = Var.getContents();
        data = new Object[ds.size()][2];
        int i = 0;
        String dom;
        for (Domain d : ds.values()) {
            dom = d.dom();
            data[i][0] = dom;
            CTO c = var.get(dom);
            if (c == null) {
                data[i][1] = "";
            } else {
                data[i][1] = CatCore.Main.normalizePath(c.fullName()).replace(CatCore.Main.CURRENT_DIRECTORY, "");
            }
            i++;
        }
        DefaultTableModel model = new DefaultTableModel(data, columnTitles);
        if (DVV != null) {
            DVV.setModel(model);
        }
    }

    @Override
    void logCellReference() {
        int rr = -1;
        int cc = -1;
        for (int r : DVV.getSelectedRows()) {
            rr = r;
        }
        for (int c : DVV.getSelectedColumns()) {
            cc = c;
        }
        if (rr == selectedRow && cc == selectedColumn) {
            return;
        }
        selectedRow = rr;
        selectedColumn = cc;
        //actOnTableEvent = true;
        if (selectedColumn == 0) {
            registerDomainEvent();
        } else {
            registerFileEvent();
        }
        normalExit();
    }

    // this method is called to service the clicking of a domain (1st column)
    // of the table  - the action is to load the selected domain with a file.
    void registerDomainEvent() {
        JFileChooser chooser = new JFileChooser(CatCore.Main.CURRENT_DIRECTORY);
        String selectedDomain = (String) data[selectedRow][0];
        String selectedExt = null;
        String fullSelectedExt = null;
        for (Domain d : Domain.getContents().values()) {
            if (d.dom().equals(selectedDomain)) {
                selectedExt = d.ext();
                fullSelectedExt = d.dom() + "." + d.ext();
            }
        }
        //postCatLiteMsg("right after " + fullSelectedExt);
        FileNameExtensionFilter filter = new FileNameExtensionFilter(selectedDomain + " files", selectedExt);
        chooser.setFileFilter(filter);
        int returnVal = chooser.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File sf = chooser.getSelectedFile();
            String sfn = CatCore.Main.normalizePath(CatCore.Main.GetAbsolutePath(sf));
            if (sfn.endsWith(fullSelectedExt)) {
//                if (!sfn.startsWith(CatCore.Main.CURRENT_DIRECTORY)) {
                // reset current directory
                int indx = sfn.lastIndexOf("/");
                String newCurrentDirectory = sfn.substring(0, indx + 1);
                CatCore.Main.CURRENT_DIRECTORY = newCurrentDirectory;
                //CatCore.Main.configFile.put("CURRENT_DIRECTORY", newCurrentDirectory);
                //selectedFileName.substring(CatCore.Main.CURRENT_DIRECTORY.length() - 1);
//                }
                //gui.postCatLiteMsg("file " + sf.getName() + " is selected");
                Var.put(CatCore.Main.GetAbsolutePath(sf));
                //                gui.data[gui.selectedRow][1] = sfn;
                //                gui.DVV.revalidate();
                //DefaultTableModel model = (DefaultTableModel) gui.DVV.getModel();
                //model.fireTableDataChanged();
                //gui.DVV.setModel(model);
                //gui.DVV.repaint();new String [] {"Domain", "FileValue"}
                //initTable();
                //                DefaultTableModel model = new DefaultTableModel(gui.data, gui.columnTitles);
                //                gui.DVV.setModel(model);
                //System.out.println("HERE" + gui.data[1][0] + ","+ gui.data[1][1]);
                //gui.DVV.validate();
            } else {
                JOptionPane.showMessageDialog(this, "selected file does not end in " + fullSelectedExt + " -- try again", "Error!", JOptionPane.ERROR_MESSAGE);
            }
        }
    }

    AorP findArrow(String action) {
        for (AorP a : AorP.getContents().values()) {
            if (a.name().equals(action)) {
                return a;
            }
        }
        return null;
    }

    public void executeArrowByName(String arrowName) {
        executeArrow(AorP.get(arrowName));
    }
    
    @Override
    public void executeArrow(Arw arrow) {
        // Step 0 : terminate all running processes
        // the following solution is especially crude, but
        // on a windows platform, you have to expect hacks like this

        String[] cmdg = {"cmd", "/c", "taskkill", "/F", "/IM", "gvim.exe"};
        ExeMethods.execute(cmdg);

        String[] cmdp = {"cmd", "/c", "taskkill", "/F", "/IM", "swipl-win.exe"};
        ExeMethods.execute(cmdp);

//        for (Process p : processGroup) {
//            p.destroy();
//        }
//        processGroup.clear();
        executeArrowWithoutKillingTasks(arrow);
    }
    
    @Override
    public void executeArrowWithoutKillingTasks(Arw arrow) {
        // Step 1 -- throw away prior error files
        File con = new File(CatCore.Main.conformMsgFile());
        con.delete();
        File err = new File(CatCore.Main.errorMsgFile());
        err.delete();
        // Step 2: if we are at a roadblock, tell user so and leave
        if (blockFurtherExecution) {
            arrow2Execute = null;
            postCatLiteMsg("all execution is stopped -- only when a new path is entered, will execution resume");
            return;
        }
        // Step 3: what kind of arrow to process?  There are
        // 3 types of arws: arrowfake, arrowpath, or arrow.
        // Step 3a: don't execute fake arrows -- which simply mark the end
        // of arrow path.  such arrows are needed to mark the
        // end of "StepOut" operations
        if (arrow instanceof ArrowFake) {
            return;
        }
        // Step 3b: now, compute the target (Prolog) schema file, (Prolog) conform file,
        // and target arrow file.  this is needed for opening edit windows for each
        // of these files. Do assign values differently per arrow type
        arrow2Execute = arrow;

        // Step 4: start the arrow and an alarm clock.  The clock runs
        // for something like 2 seconds.  In the meantime, the arrow
        // executes.  When it is done, "executionFinished is set to true
        // set to true.  now, it is a race to see which finishes first.
        // so I put the main thread into a spin loop, awakening every
        // so often to see which finishes first.
        AlarmClock ac = new AlarmClock();
        RunArrow ra = new RunArrow(this, arrow);
        executionFinished = false;
        ac.start();
        ra.start();
        try {
            while (true) {
                Thread.sleep(200);
                if (executionFinished || !ac.isAlive()) {
                    break;
                }
            }
        } catch (InterruptedException e) {
        }
        // Step 5: ok -- either the alarm clock went off, meaning that
        // the arrow is taking too long to execute and may be in an infinite
        // loop, OR the arrow is finished.  If it is still executing,
        // I kill the arrow execution, so that no other thread is running
        // this is a race condition -- the arrow might finish before the
        // uses says kill it.
        if (!executionFinished) {
            JOptionPane.showMessageDialog(this, arrow.name() + " still running -- stop?");
            if (CTO.currentProcessExecuting != null && !executionFinished) {
                postCatLiteMsg(arrow.name() + " process terminated");
                CTO.currentProcessExecuting.destroy();
                CTO.currentProcessExecuting = null;
            }
        }
        if (arrow instanceof Arrow) {
            arrow.startComputingIOArray();
            arrow.finishComputingIOArray();
        } else {
            io = null;
        }

        // Step 6: now that io array has been computed, update the panels
        updateTabbedPanes();
    }


    @Override
    public int updateMessageBoard(JTextArea a, String fileName, int component) {
        try {
            File f = new File(fileName);
            if (f.length() == 0) {
                a.setText("");
                return 0;
            }
            FileInputStream fis = new FileInputStream(f);
            byte[] fileContents = new byte[(int) f.length()];
            fis.read(fileContents);
            fis.close();
            String contents = new String(fileContents);
            a.setText(contents);
            return component;
        } catch (Exception e) {
            postCatLiteMsg(e.getMessage());
            return 0;
        }
    }

    // this clears a message board of text and deletes a corresponding file
    @Override
    public void clearBoard(JTextArea a, String fileName) {
        try {
            File f = new File(fileName);
            f.delete();
            a.setText("");
        } catch (Exception e) {
            System.err.println(e.getMessage());
        }
    }

}
