package CatGui;

/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
import CatCore.Arrows.AorP;
import CatCore.Arrows.Arrow;
import CatCore.Arrows.ArrowJava;
import CatCore.Arrows.ArrowPath;
import CatCore.Arrows.ArrowProlog;
import CatCore.Arrows.ArrowVm;
import CatCore.Arrows.Arw;
import CatCore.CTO;
import CatCore.Domains.Domain;
import CatCore.ExeMethods;
import CatCore.ExecutionError;
import CatCore.Var;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.LinkedList;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.ListSelectionModel;
import javax.swing.ScrollPaneConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.text.DefaultCaret;

/**
 *
 * @author dsb
 */
public abstract class MainGui extends javax.swing.JFrame {

    int counter = 0;
    String[] ListOfArrows;                                    // this is the list of all arrows, paths in the metamodel
    LinkedList<Arw> arrowQueue = new LinkedList<>();          // this is the arrow execution queue
    public Object[][] data;                                   // this is the data that is loaded into the table
    String[] columnTitles
            = new String[]{"Domain", "FileValue"};            // and this is the column tabs of this table

    int selectedRow = -1, selectedColumn = -1;                // when the table is clicked, these variables are set to the
    // row and column numbers
    //boolean actOnTableEvent = false;                        // no idea what this was originally used for
    public String hiliteDomain;                               // this is used in Advice -- to highlight an input domain

    boolean blockFurtherExecution = false;                    // this flag is set when an arrow execution fails
    // until this flag is cleared (set false), no further
    // arrow executions are permitted
    // boolean showPredefinedPaths = false;                   // no idea what this was originally used for

    // boolean executeArrow = false;                          // no idea what this variable was used for
    boolean usePanel1 = true;                                 // to be retired...

    Arw arrow2Execute = null;                                  // arrow that is (was) just executed
    public boolean executionFinished = false;                  // has currently forked arrow (namely arrow2Execute) finished execution?

    // Given most recent arrow produced a prolog file...
    public static String targetSchema = null;                  // location of the (Prolog) schema file 
    public static String targetConform = null;                 // location of the (Prolog) conform file
    public static String arrowFile = null;                     // location of the transformation file that produced the prolog file
    // this is the fullName() of the result produced by "executeArrow"
    // and may be a prolog or vm file
    public static String[] io = null;                          // a command array to execute to display input and output files

    /**
     * Creates new form NewApplication
     */
    public MainGui() {
        // Step 1: initialize CatLite/CatCore
        CatCore.Main.initDictionaries();

        // Step 2: now initialize the mode
        initArrows();
        initTable();

        // Step 3: now clear the GUI, with its defaults
        initComponents();

        // Step 4: add magic listeners for table -- so that we can read cell selections
        DVV.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        DVV.getSelectionModel().addListSelectionListener(new RowListener());
        DVV.getColumnModel().getSelectionModel().addListSelectionListener(new ColumnListener());
        DVV.setCellSelectionEnabled(true);
        DVV.setRowSelectionAllowed(true);
        DVV.setColumnSelectionAllowed(true);

        // CatLiteMsgs window should always show most recent messages and
        // the scroller should follow the last message
        DefaultCaret caret = (DefaultCaret) CatLiteMsgs.getCaret();
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
        CatLiteMsgs.setEditable(false);

        clearMessageBoards();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                CatCore.Main.updateConfigFile("");
                System.exit(0);
            }
        });

    }

    abstract void initArrows();

    abstract void initTable();

    abstract void logCellReference();

    abstract void executeArrow(Arw arrow);

    abstract void executeArrowWithoutKillingTasks(Arw arrow);

//    abstract Process execute(String... cmdarray);
    // utilities
    public Component colorRowsOfTable(Component stamp, int row) {
        String domainName;
        String[] domains;
        String[] ranges;
        Arrow a;
        if (arrowQueue.isEmpty()) {
            stamp.setBackground(getBackground());
            if (hiliteDomain != null) {
                domainName = (String) data[row][0];
                if (hiliteDomain.equals(domainName)) {
                    stamp.setBackground(Color.cyan);
                }
                return stamp;
            }
        }
        hiliteDomain = null;

        Arw top = arrowQueue.peekFirst();
        if (!(top instanceof Arrow)) {
            stamp.setBackground(getBackground());
            return stamp;
        }
        a = (Arrow) top;
        domains = a.domains();
        ranges = a.ranges();
        domainName = (String) data[row][0];
        for (String d : domains) {
            if (d.equals(domainName)) {
                stamp.setBackground(Color.yellow);
                return stamp;
            }
        }
        if (ranges[0].equals(domainName)) {
            stamp.setBackground(Color.orange);
        } else {
            stamp.setBackground(getBackground());
        }
        return stamp;
    }

    class RowListener implements ListSelectionListener {

        public void valueChanged(ListSelectionEvent event) {
            if (event.getValueIsAdjusting()) {
                return;
            }
            logCellReference();
        }
    }

    public class ColumnListener implements ListSelectionListener {

        public void valueChanged(ListSelectionEvent event) {
            if (event.getValueIsAdjusting()) {
                return;
            }
            logCellReference();
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ErrorTabs = new javax.swing.JTabbedPane();
        CatLiteErrors = new javax.swing.JInternalFrame();
        jScrollPane5 = new javax.swing.JScrollPane();
        CatLiteMsgs = new javax.swing.JTextArea();
        ConformanceErrors = new javax.swing.JInternalFrame();
        jScrollPane4 = new javax.swing.JScrollPane();
        ConformanceMsgs = new javax.swing.JTextArea();
        ArrowErrors = new javax.swing.JInternalFrame();
        jScrollPane3 = new javax.swing.JScrollPane();
        ArrowMsgs = new javax.swing.JTextArea();
        tabbedEditorPanel1 = new javax.swing.JTabbedPane();
        ButtonPanel = new javax.swing.JPanel();
        StepOut = new javax.swing.JButton();
        StartOver = new javax.swing.JButton();
        StepIn = new javax.swing.JButton();
        Step = new javax.swing.JButton();
        run = new javax.swing.JButton();
        ClearMsgs = new javax.swing.JButton();
        EditConform = new javax.swing.JButton();
        SaveState = new javax.swing.JButton();
        RestoreSTate = new javax.swing.JButton();
        RedoLast = new javax.swing.JButton();
        EditXform = new javax.swing.JButton();
        closeEdits = new javax.swing.JButton();
        EditIO = new javax.swing.JButton();
        help = new javax.swing.JButton();
        executePanel = new javax.swing.JPanel();
        ExecuteTextField = new javax.swing.JTextField();
        ArrowSelection = new javax.swing.JComboBox();
        enter = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        DVVLabe = new javax.swing.JLabel();
        FileValuesLabel = new javax.swing.JLabel();
        ValuesPanel = new javax.swing.JScrollPane();
        DVV = new MyJTable(this); //new javax.swing.JTable();
        tabbedEditorPanel2 = new javax.swing.JTabbedPane();
        menuBar = new javax.swing.JMenuBar();
        helpMenu = new javax.swing.JMenu();
        contentsMenuItem = new javax.swing.JMenuItem();
        aboutMenuItem = new javax.swing.JMenuItem();
        Tools = new javax.swing.JMenu();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);

        ErrorTabs.setToolTipText("errors produced by most recent arrow execution");
        ErrorTabs.setName("ArrowErrors"); // NOI18N

        CatLiteErrors.setBorder(null);
        CatLiteErrors.setVisible(true);

        CatLiteMsgs.setColumns(20);
        CatLiteMsgs.setRows(5);
        jScrollPane5.setViewportView(CatLiteMsgs);

        javax.swing.GroupLayout CatLiteErrorsLayout = new javax.swing.GroupLayout(CatLiteErrors.getContentPane());
        CatLiteErrors.getContentPane().setLayout(CatLiteErrorsLayout);
        CatLiteErrorsLayout.setHorizontalGroup(
            CatLiteErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 466, Short.MAX_VALUE)
        );
        CatLiteErrorsLayout.setVerticalGroup(
            CatLiteErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane5, javax.swing.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
        );

        ErrorTabs.addTab("CatLiteMsgs", CatLiteErrors);

        ConformanceErrors.setBorder(null);
        ConformanceErrors.setToolTipText("errors from most recent conformance test");
        ConformanceErrors.setVisible(true);

        ConformanceMsgs.setColumns(20);
        ConformanceMsgs.setRows(5);
        jScrollPane4.setViewportView(ConformanceMsgs);

        javax.swing.GroupLayout ConformanceErrorsLayout = new javax.swing.GroupLayout(ConformanceErrors.getContentPane());
        ConformanceErrors.getContentPane().setLayout(ConformanceErrorsLayout);
        ConformanceErrorsLayout.setHorizontalGroup(
            ConformanceErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 466, Short.MAX_VALUE)
        );
        ConformanceErrorsLayout.setVerticalGroup(
            ConformanceErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane4, javax.swing.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
        );

        ErrorTabs.addTab("ConformanceMsgs", ConformanceErrors);

        ArrowErrors.setBorder(null);
        ArrowErrors.setVisible(true);

        ArrowMsgs.setColumns(20);
        ArrowMsgs.setRows(5);
        jScrollPane3.setViewportView(ArrowMsgs);

        javax.swing.GroupLayout ArrowErrorsLayout = new javax.swing.GroupLayout(ArrowErrors.getContentPane());
        ArrowErrors.getContentPane().setLayout(ArrowErrorsLayout);
        ArrowErrorsLayout.setHorizontalGroup(
            ArrowErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 466, Short.MAX_VALUE)
        );
        ArrowErrorsLayout.setVerticalGroup(
            ArrowErrorsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jScrollPane3, javax.swing.GroupLayout.DEFAULT_SIZE, 135, Short.MAX_VALUE)
        );

        ErrorTabs.addTab("ErrorMsgs", null, ArrowErrors, "errors from most recent arrow execution");

        tabbedEditorPanel1.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabbedEditorPanel1.setFont(new java.awt.Font("Courier New", 1, 14)); // NOI18N
        tabbedEditorPanel1.setName("file contents"); // NOI18N
        tabbedEditorPanel1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabbedEditorPanel1MouseClicked(evt);
            }
        });

        StepOut.setText("StepOut");
        StepOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StepOutActionPerformed(evt);
            }
        });

        StartOver.setText("StartOver");
        StartOver.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StartOverActionPerformed(evt);
            }
        });

        StepIn.setText("StepIn");
        StepIn.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StepInActionPerformed(evt);
            }
        });

        Step.setText("Step");
        Step.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StepActionPerformed(evt);
            }
        });

        run.setText("Run");
        run.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                runActionPerformed(evt);
            }
        });

        ClearMsgs.setText("ClearMsgs");
        ClearMsgs.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ClearMsgsActionPerformed(evt);
            }
        });

        EditConform.setText("EditConform");
        EditConform.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditConformActionPerformed(evt);
            }
        });

        SaveState.setText("SaveState");
        SaveState.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                SaveStateActionPerformed(evt);
            }
        });

        RestoreSTate.setText("RestoreState");
        RestoreSTate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RestoreSTateActionPerformed(evt);
            }
        });

        RedoLast.setText("RedoLast");
        RedoLast.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RedoLastActionPerformed(evt);
            }
        });

        EditXform.setText("EditXform");
        EditXform.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditXformActionPerformed(evt);
            }
        });

        closeEdits.setText("CloseAll");
        closeEdits.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeEditsActionPerformed(evt);
            }
        });

        EditIO.setText("Edit I/O Files");
        EditIO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EditIOActionPerformed(evt);
            }
        });

        help.setText("Now what do I do?");
        help.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                helpActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ButtonPanelLayout = new javax.swing.GroupLayout(ButtonPanel);
        ButtonPanel.setLayout(ButtonPanelLayout);
        ButtonPanelLayout.setHorizontalGroup(
            ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ButtonPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(ButtonPanelLayout.createSequentialGroup()
                        .addComponent(Step, javax.swing.GroupLayout.PREFERRED_SIZE, 70, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(StepIn)
                        .addGap(18, 18, 18)
                        .addComponent(StepOut)
                        .addGap(18, 18, 18)
                        .addComponent(run, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(ButtonPanelLayout.createSequentialGroup()
                        .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addGroup(ButtonPanelLayout.createSequentialGroup()
                                .addComponent(EditXform)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(EditConform))
                            .addGroup(ButtonPanelLayout.createSequentialGroup()
                                .addComponent(RestoreSTate)
                                .addGap(18, 18, 18)
                                .addComponent(StartOver)))
                        .addGap(18, 18, 18)
                        .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ClearMsgs)
                            .addGroup(ButtonPanelLayout.createSequentialGroup()
                                .addGap(12, 12, 12)
                                .addComponent(EditIO))))
                    .addComponent(help, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 236, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(SaveState, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 96, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(closeEdits, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(RedoLast, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        ButtonPanelLayout.setVerticalGroup(
            ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ButtonPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(Step)
                    .addComponent(StepIn)
                    .addComponent(StepOut)
                    .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(run)
                        .addComponent(RedoLast)))
                .addGap(14, 14, 14)
                .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RestoreSTate)
                    .addComponent(StartOver)
                    .addComponent(ClearMsgs)
                    .addComponent(SaveState))
                .addGap(10, 10, 10)
                .addGroup(ButtonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(EditConform, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(EditIO, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(closeEdits, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(EditXform, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(help)
                .addGap(4, 4, 4))
        );

        ExecuteTextField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExecuteTextFieldActionPerformed(evt);
            }
        });

        ArrowSelection.setModel(new javax.swing.DefaultComboBoxModel(ListOfArrows));
        ArrowSelection.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ArrowSelectionActionPerformed(evt);
            }
        });

        enter.setText("ExecutionPath");
        enter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                enterActionPerformed(evt);
            }
        });

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("PredefinedArrows");

        DVVLabe.setText("Domains");

        FileValuesLabel.setText("File Values");

        DVV.setModel(new javax.swing.table.DefaultTableModel(
            data,
            columnTitles
        ));
        DVV.setName("DVV"); // NOI18N
        ValuesPanel.setViewportView(DVV);

        javax.swing.GroupLayout executePanelLayout = new javax.swing.GroupLayout(executePanel);
        executePanel.setLayout(executePanelLayout);
        executePanelLayout.setHorizontalGroup(
            executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, executePanelLayout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(ValuesPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 469, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, executePanelLayout.createSequentialGroup()
                        .addComponent(DVVLabe, javax.swing.GroupLayout.PREFERRED_SIZE, 160, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(FileValuesLabel)
                        .addContainerGap())
                    .addGroup(executePanelLayout.createSequentialGroup()
                        .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(enter, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                            .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ExecuteTextField)
                            .addComponent(ArrowSelection, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))))
        );
        executePanelLayout.setVerticalGroup(
            executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(executePanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ArrowSelection, javax.swing.GroupLayout.PREFERRED_SIZE, 20, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ExecuteTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(enter))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(executePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(DVVLabe)
                    .addComponent(FileValuesLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ValuesPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 224, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        tabbedEditorPanel2.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        tabbedEditorPanel2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabbedEditorPanel2MouseClicked(evt);
            }
        });

        helpMenu.setMnemonic('h');
        helpMenu.setText("Help");

        contentsMenuItem.setMnemonic('c');
        contentsMenuItem.setText("Contents");
        contentsMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                contentsMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(contentsMenuItem);

        aboutMenuItem.setMnemonic('a');
        aboutMenuItem.setText("About");
        helpMenu.add(aboutMenuItem);

        menuBar.add(helpMenu);

        Tools.setText("Tools");
        menuBar.add(Tools);

        setJMenuBar(menuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ErrorTabs, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addComponent(ButtonPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(executePanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addGap(3, 3, 3)
                .addComponent(tabbedEditorPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, 336, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(tabbedEditorPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 345, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(tabbedEditorPanel2)
                    .addComponent(tabbedEditorPanel1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(executePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(ButtonPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(ErrorTabs, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        ErrorTabs.getAccessibleContext().setAccessibleName("ArrowErrors");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void ArrowSelectionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ArrowSelectionActionPerformed
        String name = (String) ArrowSelection.getSelectedItem();
        int indx = name.indexOf(" ");
        if (indx > 0) {
            name = name.substring(0, indx).trim();
        }
        ExecuteTextField.setText(name);
        enterActionPerformed(null);

    }//GEN-LAST:event_ArrowSelectionActionPerformed

    private void ExecuteTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExecuteTextFieldActionPerformed
        // do nothing
    }//GEN-LAST:event_ExecuteTextFieldActionPerformed

    private void enterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_enterActionPerformed
        AorP[] body;
        // Step 1: when enter is clicked, a path (typically just a single arrowname)
        // has been entered.  parse the path.  If it is OK, proceed to execution
        // otherwise report an error and don't proceed until it is fixed.

        String line = ExecuteTextField.getText();
        ArrowPath s = new ArrowPath(line);
        String result = s.validate();
        if (!result.equals("")) {
            postCatLiteMsg(result);
            blockFurtherExecution = true;
            return;
        }

        // Step 2: we're ready to execute the arrow
        // clear the queue and enter the result
        blockFurtherExecution = false;
        arrowQueue.clear();
        try {
            body = s.getPath();
        } catch (ExecutionError e) {
            postCatLiteMsg(e.getMessage());
            return;
        }

        // all good arrows -- load them into the queue for execution
        for (int i = body.length - 1; i >= 0; i--) {
            arrowQueue.offerFirst(body[i]);
        }
        clearMessageBoards();
        postCatLiteMsg("path entered -- ready to execute");
        normalExit();
    }//GEN-LAST:event_enterActionPerformed

    static final char quote = '"';

    void restoreState() {
        try {
            ObjectInputStream ois = new ObjectInputStream(new FileInputStream("savedState.ser"));
            Var.putContents((HashMap<String, CTO>) ois.readObject());
            arrowQueue = (LinkedList<Arw>) ois.readObject();
            ois.close();
        } catch (IOException | ClassNotFoundException e) {
            postCatLiteMsg("unable to restore state " + e.getMessage());
        }
        postCatLiteMsg("restored state");
        blockFurtherExecution = false;
        normalExit();
    }

    void mouseClicked(JTabbedPane tp, MouseEvent evt) {
        int x = tp.getSelectedIndex();
        int m = evt.getModifiers();
        if (evt.getModifiers() == InputEvent.BUTTON3_MASK) {
            Component c = tp.getComponentAt(x);
            if (c == null) {
                postCatLiteMsg("there is no tab/file selected");
                return;
            }
            String fileName = CatCore.Main.CURRENT_DIRECTORY + c.getName();
            //System.out.println(c.getName());
            forkTextEditor(fileName);
            normalExit();
        }
    }
    private void tabbedEditorPanel1MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tabbedEditorPanel1MouseClicked
        mouseClicked(tabbedEditorPanel1, evt);

    }//GEN-LAST:event_tabbedEditorPanel1MouseClicked

    private void tabbedEditorPanel2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tabbedEditorPanel2MouseClicked
        mouseClicked(tabbedEditorPanel2, evt);
    }//GEN-LAST:event_tabbedEditorPanel2MouseClicked

    private void EditXformActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditXformActionPerformed
        if (arrow2Execute == null) {
            postCatLiteMsg("nothing was executed");
            return;
        }
        if (arrow2Execute instanceof ArrowProlog) {
            // create 2 windows -- swi-prolog-window, and text editor of arrowFile
            // in this case, a .pl file that was executed by arrow2Execute
            forkSwiProlog(CatCore.Main.PLExeFile());
            forkTextEditor(arrowFile); // target Conform;
        } else if (arrow2Execute instanceof ArrowVm) {
            forkTextEditor(arrowFile);
        } else if (arrow2Execute instanceof ArrowJava) {
            JOptionPane.showMessageDialog(this,
                    arrow2Execute.name() + " is a java executable -- edit & rebuild before replaying",
                    "Alert",
                    JOptionPane.WARNING_MESSAGE);
        } else {
            JOptionPane.showMessageDialog(this,
                    arrow2Execute.name() + " is not an arrow to debug",
                    "Alert",
                    JOptionPane.WARNING_MESSAGE);
        }
        normalExit();
    }//GEN-LAST:event_EditXformActionPerformed

    private void RedoLastActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RedoLastActionPerformed

        if (arrow2Execute != null) {
            postCatLiteMsg("replaying " + arrow2Execute.name());
            blockFurtherExecution = false;
            ExecuteTextField.setText(arrow2Execute.name());
            executeArrowWithoutKillingTasks(arrow2Execute);
        } else {
            postCatLiteMsg("nothing to execute");
        }
        normalExit();
    }//GEN-LAST:event_RedoLastActionPerformed

    private void RestoreSTateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RestoreSTateActionPerformed
        StartOverActionPerformed(null);
        restoreState();
        clearMessageBoards();
    }//GEN-LAST:event_RestoreSTateActionPerformed

    private void SaveStateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_SaveStateActionPerformed
        try {
            ObjectOutputStream fos = new ObjectOutputStream(new FileOutputStream("savedState.ser"));
            fos.writeObject(Var.getContents());
            fos.writeObject(arrowQueue);
            fos.close();
        } catch (IOException e) {
            postCatLiteMsg("cannot save state " + e.getMessage());
        }
        postCatLiteMsg("saved state");
        normalExit();
    }//GEN-LAST:event_SaveStateActionPerformed

    private void EditIOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditIOActionPerformed
        if (arrowFile == null) {
            JOptionPane.showMessageDialog(this,
                    "Arrow " + arrow2Execute.name() + " is not prolog or vm -- java?",
                    "Alert",
                    JOptionPane.WARNING_MESSAGE);
            //postCatLiteMsg("no prolog/vm transformation file for this arrow");
        } else {
            forkTextEditorsIO();
        }
    }//GEN-LAST:event_EditIOActionPerformed

    private void EditConformActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EditConformActionPerformed

        if (arrow2Execute == null) {
            JOptionPane.showMessageDialog(this,
                    "nothing was produced that required a conformation check",
                    "Alert",
                    JOptionPane.WARNING_MESSAGE);
        }
        if (arrow2Execute instanceof Arrow) {
            Arrow a = (Arrow) arrow2Execute;
            String r[] = a.ranges();
            Domain d = Domain.get(r[0]);
            if (d.ext().equals("pl")) {
                // this arrow proded a pl file. the arrow could have been a java program,
                // a vm program or a pl program.  Anything that produced a pl file.  This
                // means that the file underwent a conformation test.  we create 2 windows
                // one for swi prolog and another for the target conform file 
                forkSwiProlog(CatCore.Main.PLConFile()); //Kon.X.pl
                forkTextEditor(targetConform);
            }
        } else {
            JOptionPane.showMessageDialog(this,
                    "the output file has no prolog conformation check",
                    "Alert",
                    JOptionPane.WARNING_MESSAGE);
        }
    }//GEN-LAST:event_EditConformActionPerformed

    private void ClearMsgsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ClearMsgsActionPerformed
        CatLiteMsgs.setText("");
        ConformanceMsgs.setText("");
        ArrowMsgs.setText("");
    }//GEN-LAST:event_ClearMsgsActionPerformed

    private void runActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_runActionPerformed
        Arw action;

        // execute until a null is found on the stack or the stack is empty
        while (true) {
            if (isQueueEmpty()) {
                ExecuteTextField.setText("");
                break;
            }

            action = arrowQueue.removeFirst();
            executeArrow(action);
        }
        normalExit();
    }//GEN-LAST:event_runActionPerformed

    private void StepActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StepActionPerformed

        if (isQueueEmpty()) {
            return;
        }
        executeArrow(arrowQueue.removeFirst());
        //executeArrow = true;
        normalExit();
    }//GEN-LAST:event_StepActionPerformed

    private void StepInActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StepInActionPerformed
        Arw arrow;
        String arrowName;

        if (isQueueEmpty()) {
            return;
        }

        arrow = arrowQueue.removeFirst();
        arrowName = arrow.name();

        // if the arrow to perform is a path, insert the entire
        // path into the arrow execution queue
        if (arrow instanceof ArrowPath) {
            AorP[] body = ((ArrowPath) arrow).getPath();
            arrowQueue.offerFirst(new ArrowFake(")" + arrowName));  // flag to indicate end of path -- never executed
            for (int i = body.length - 1; i >= 0; i--) {
                arrowQueue.offerFirst(body[i]);
            }
            postCatLiteMsg("arrows of path " + arrowName
                    + " are pushed onto stack -- first of its arrows to Execute is displayed");
        } else {
            executeArrow(arrow);
        }

        normalExit();
    }//GEN-LAST:event_StepInActionPerformed

    private void StartOverActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StartOverActionPerformed
        arrowQueue.clear();
        clearMessageBoards();
        tabbedEditorPanel1.removeAll();
        tabbedEditorPanel2.removeAll();
        Var.clear();
        normalExit();
    }//GEN-LAST:event_StartOverActionPerformed

    private void StepOutActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_StepOutActionPerformed
        Arw action;

        // execute until a null is found on the stack or the stack is empty
        while (true) {
            if (isQueueEmpty()) {
                return;
            }

            action = arrowQueue.removeFirst();
            if (!(action instanceof ArrowFake)) {
                executeArrow(action);
                continue;
            }
            break;
        }
        normalExit();
    }//GEN-LAST:event_StepOutActionPerformed

    private void closeEditsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeEditsActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_closeEditsActionPerformed

    private void helpActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_helpActionPerformed
        Class c;
        blockFurtherExecution = false;
        try {
            String adviceFileName = CatCore.Main.ADVICE;
            c = Class.forName(adviceFileName);
        } catch (ClassNotFoundException e) {
            postCatLiteMsg("this metamodel has no advising program");
            return;
        }
        try {
            String[] args = {};
            Object i = c.newInstance();  // not really needed but..
            Method m = c.getMethod("main", String[].class);
            m.invoke(i, (Object) args);
        } catch (InstantiationException | InvocationTargetException | IllegalAccessException | NoSuchMethodException e1) {
            postCatLiteMsg("could not execute advising program");
        }
        normalExit();
    }//GEN-LAST:event_helpActionPerformed

    private void contentsMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_contentsMenuItemActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_contentsMenuItemActionPerformed

    void normalExit() {
        while (arrowQueue.size() > 0 && arrowQueue.peekFirst() instanceof ArrowFake) {
            arrowQueue.removeFirst();
        }
        if (arrowQueue.size() == 0) {
            ExecuteTextField.setText("");
        } else {
            ExecuteTextField.setText(arrowQueue.peekFirst().name());
        }
        initTable();
        updateMessageBoards();
    }

    void unrecognizableArrow(String action) {
        postCatLiteMsg("Unrecognizable arrow " + action + "; queue cleared");
        ExecuteTextField.setText("");
        arrowQueue.clear();
    }

    boolean isQueueEmpty() {
        if (arrowQueue.size() == 0) {
            postCatLiteMsg("queue is empty -- nothing to execute");
            ExecuteTextField.setText("");
            return true;
        }
        return false;
    }

    public void postCatLiteMsg(String s) {
        CatLiteMsgs.append(s + "\n");
    }

    public abstract int updateMessageBoard(JTextArea a, String fileName, int component);

    public void updateMessageBoards() {
        int c = updateMessageBoard(ConformanceMsgs, CatCore.Main.conformMsgFile(), 1);
        int a = updateMessageBoard(ArrowMsgs, CatCore.Main.errorMsgFile(), 2);
        int min = (a > c) ? a : c;
        ErrorTabs.setSelectedIndex(min);
    }

    public abstract void clearBoard(JTextArea a, String fileName);

    public void clearMessageBoards() {
        clearBoard(ConformanceMsgs, CatCore.Main.conformMsgFile());
        clearBoard(ArrowMsgs, CatCore.Main.errorMsgFile());
        CatLiteMsgs.setText("");
    }

    // this method is called when the file column of the table was clicked.
    // the action is to display the clicked file in one of the tabs.
    void registerFileEvent() {
        int selectedTabIndex;
        JTabbedPane selectedTabbedPanel;

        // Step 0: not sure that this is needed, but just in case
        if (selectedRow == -1 || selectedColumn == -1) {
            return;
        }

        // Step 1: determine the actual file name that was clicked
        // if the file was empty (unspecified), just return and ignore the click
        String fileName = (String) data[selectedRow][selectedColumn];
        if (fileName.equals("")) {
            return;
        }

        // Step 3: now, let's see which editor panel the selected file may be on
        // it is is already on a panel, return the panel (in "selectedTabbedPanel") and the
        // tab indx in "selectedTabIndex"
        selectedTabbedPanel = tabbedEditorPanel1;
        selectedTabIndex = selectedTabbedPanel.indexOfTab(fileName);
        if (selectedTabIndex < 0) {
            selectedTabbedPanel = tabbedEditorPanel2;
            selectedTabIndex = tabbedEditorPanel2.indexOfTab(fileName);
        }

        // Step 4: if file is already displayed in a tab, highlight it
        if (selectedTabIndex >= 0) {
            selectedTabbedPanel.setSelectedIndex(selectedTabIndex);
            return;
        }

        // Step 5: create a panel with filename on panel1
        postFileOnPanel(tabbedEditorPanel1, CatCore.Main.CURRENT_DIRECTORY + fileName);

        // Step 5: the file that was selected was not displayed in an existing tab
//        JTextArea newTab;
//        try {
//            // Step Create a new (read-only) scrollable tab, load it with the data of the file
//            newTab = new JTextArea(20, 30);
//            newTab.setEditable(false);
//            newTab.setName(fileName);
//            newTab.setFont(new Font("Courier New", Font.PLAIN, 14));
//            fullFileName = CatCore.Main.CURRENT_DIRECTORY + "/" + fileName;
//            byte[] encoded = Files.readAllBytes(Paths.get(fullFileName));
//            String fileContents = new String(encoded);
//            newTab.setText(fileContents);
//        } catch (Exception e) {
//            postCatLiteMsg("cannot create tab for file " + fullFileName);
//            postCatLiteMsg(e.getMessage());
//            return;
//        }
//
//        JScrollPane jsp = new JScrollPane(newTab);
//        jsp.setName(fileName);
//        jsp.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
//        jsp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
//
////        // Step 6: if panel1 is not empty, simply move all the tabs on panel1 to panel2
////        if (tabbedEditorPanel1.getTabCount()>0) {
////            moveTabsOn1to2(tabbedEditorPanel1,tabbedEditorPanel2);
////        }
//        // Step 7:  display the new tab on panel1 -- create a close button for it
//        tabbedEditorPanel1.add(fileName, jsp);
//        int indx = tabbedEditorPanel1.indexOfComponent(jsp);
//        CloseButton cb = new CloseButton(tabbedEditorPanel1);
//        tabbedEditorPanel1.setTabComponentAt(indx, cb);
//        tabbedEditorPanel1.setSelectedIndex(indx);
    }

    void postFileOnPanel(JTabbedPane p, String longFileName) {
        JTextArea newTab;
        String shortFileName;

        // Step 1: Create a jtextarea that has the contents of the given file.
        newTab = new JTextArea(20, 30);
        newTab.setEditable(false);
        newTab.setName(longFileName);
        newTab.setFont(new Font("Courier New", Font.PLAIN, 14));
        int idx = longFileName.lastIndexOf("/") + 1;
        shortFileName = longFileName.substring(idx);
        try {

            byte[] encoded = Files.readAllBytes(Paths.get(longFileName));
            String fileContents = new String(encoded);
            newTab.setText(fileContents);
        } catch (IOException e) {
            postCatLiteMsg("cannot create tab for file " + shortFileName);
            postCatLiteMsg(e.getMessage());
            return;
        }

        // Step 2: now make it scrollable
        JScrollPane jsp = new JScrollPane(newTab);
        jsp.setName(shortFileName);
        jsp.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        jsp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);

        // Step 3:  now add it, along with a close button onto panel p
        p.add(shortFileName, jsp);
        int indx = p.indexOfComponent(jsp);
        CloseButton cb = new CloseButton(p);
        p.setTabComponentAt(indx, cb);
        p.setSelectedIndex(indx);
    }

    void moveTabsOn1to2(JTabbedPane p1, JTabbedPane p2) {
        p2.removeAll();
        int tcount = p1.getTabCount();
        for (int i = 0; i < tcount; i++) {
            Component c = p1.getComponentAt(i);
            postCatLiteMsg("component name " + c.getName());
            p1.remove(i);
            p2.addTab(c.getName(), c);
            p2.setTabComponentAt(i, new CloseButton(p2));
        }
    }

    void refreshTabbedPane(JTabbedPane p) {
        int i = p.getTabCount();
        for (int j = 0; j < i; j++) {
            JScrollPane jsp = (JScrollPane) p.getComponentAt(j);
            JViewport vp = jsp.getViewport();
            JTextArea a = (JTextArea) vp.getView();
            String fileName = a.getName();
            try {
                byte[] encoded = Files.readAllBytes(Paths.get(fileName));
                String fileContents = new String(encoded);
                a.setText(fileContents);
            } catch (IOException e) {
                postCatLiteMsg("cannot refresh tab for file " + fileName);
                postCatLiteMsg(e.getMessage());
                return;
            }
        }
    }

    void updateTabbedPanes() {
        int i;
        JTabbedPane p1 = tabbedEditorPanel1;
        JTabbedPane p2 = tabbedEditorPanel2;

        // Step 0: if nothing has been declared, we're done
        if (io == null) {
            refreshTabbedPane(p1);
            refreshTabbedPane(p2);
            return;
        }

        // Step 1: remove all tabs from both panels
        p1.removeAll();
        p2.removeAll();

        // Step 2: io is a command array, starting with something like
        // "gvim" "-O2" inputfile1 inputfile2 ... outputfile.  The information
        // that we want starts at index 2 (inputfile1).
        // create tabs on panel1 for all the input files
        int size = io.length - 1;
        for (i = 2; i < size; i++) {
            postFileOnPanel(tabbedEditorPanel1, io[i]);
        }

        // Step 3: create tab on panel2 for the lone output
        postFileOnPanel(tabbedEditorPanel2, io[i]);
    }

    void printio() {
        String ios = ExeMethods.makeString(MainGui.io);
        System.out.println(ios);
    }

    void forkSwiProlog(String shortFileName) {
//        String[] cmd = {"cmd", "/c", "start", CatCore.Main.SWIPL_WIN_EXE, shortFileName};
        ExeMethods.execute("cmd", "/c", "start", CatCore.Main.SWIPL_WIN_EXE, shortFileName);
    }

    void tryThis(String swi, String file) {
        String[] cmd = {swi, file};
        ExeMethods.execute(cmd);
        JOptionPane.showMessageDialog(this,
                swi + " " + file,
                "Alert",
                JOptionPane.WARNING_MESSAGE);
    }

    void forkTextEditor(String longFileName) {
        // This is a hack -- gvim, the text editor that I'm using, leaves behind
        // a swap file when a text file is edited.  Gvim looks for this file -- if
        // it finds it, then it thinks either there are 2 Gvim editors trying to
        // edit the same text file OR GVIM crashed and Gvim needs to use this
        // swap file for recover.  In any case, the swap file must be deleted.
        // So to avoid annoying Gvim warnings, I have to delete swap files.
        // Given path "..../<myfile>" to edit, the swap file name is
        // "..../.<myfile>.swp" -- that is the file to delete

        deleteAllGvimDotSWFiles(longFileName);
        String[] cmd2 = {CatCore.Main.GVIM_EXE, longFileName};
        ExeMethods.execute(cmd2);
    }

    void forkTextEditorsIO() {
        // a continuation of the hack above, now for an array of text files.
        for (int i = 2; i < io.length; i++) {
            String s = io[i];
            if (!s.equals(CatCore.Main.errorMsgFile())) {
                deleteAllGvimDotSWFiles(s);
            }
        }
        ExeMethods.execute(MainGui.io);
    }

    // gvim produces .swp, .swo, .sw? files for recovery.
    // just delete 'em all
    void deleteAllGvimDotSWFiles(String longFileName) {
        int indx = longFileName.lastIndexOf("/");
        String dirOfLongFileName = longFileName.substring(0, indx);
        File folder = new File(dirOfLongFileName);
        File[] arrayOfFiles = folder.listFiles();
        for (File f : arrayOfFiles) {
            if (f.isFile()) {
                String filename = f.getName();
                indx = filename.length();
                filename = filename.substring(0, indx - 1);
                if (filename.endsWith(".sw") && filename.startsWith(".")) {
                    f.delete();
                }
            }
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JInternalFrame ArrowErrors;
    private javax.swing.JTextArea ArrowMsgs;
    private javax.swing.JComboBox ArrowSelection;
    private javax.swing.JPanel ButtonPanel;
    private javax.swing.JInternalFrame CatLiteErrors;
    private javax.swing.JTextArea CatLiteMsgs;
    private javax.swing.JButton ClearMsgs;
    private javax.swing.JInternalFrame ConformanceErrors;
    private javax.swing.JTextArea ConformanceMsgs;
    public javax.swing.JTable DVV;
    private javax.swing.JLabel DVVLabe;
    private javax.swing.JButton EditConform;
    private javax.swing.JButton EditIO;
    private javax.swing.JButton EditXform;
    private javax.swing.JTabbedPane ErrorTabs;
    private javax.swing.JTextField ExecuteTextField;
    private javax.swing.JLabel FileValuesLabel;
    private javax.swing.JButton RedoLast;
    private javax.swing.JButton RestoreSTate;
    private javax.swing.JButton SaveState;
    private javax.swing.JButton StartOver;
    private javax.swing.JButton Step;
    private javax.swing.JButton StepIn;
    private javax.swing.JButton StepOut;
    private javax.swing.JMenu Tools;
    private javax.swing.JScrollPane ValuesPanel;
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JButton closeEdits;
    private javax.swing.JMenuItem contentsMenuItem;
    private javax.swing.JButton enter;
    private javax.swing.JPanel executePanel;
    private javax.swing.JButton help;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JMenuBar menuBar;
    private javax.swing.JButton run;
    private javax.swing.JTabbedPane tabbedEditorPanel1;
    private javax.swing.JTabbedPane tabbedEditorPanel2;
    // End of variables declaration//GEN-END:variables

}
