/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CatGui;

import CatCore.Arrows.Arw;
import CatCore.ConformanceError;
import CatCore.ExecutionError;

/**
 *
 * @author dsb
 * this program is a thread that is spawned to run an arrow.
 * in case the arrow falters or runs forever, the GUI thread
 * is isolated from such disasters.  When arrow finishes,
 * the gui refresh() method is called to signal the execution is done.
 */
public class RunArrow extends Thread {

    MainGui gui;
    public Arw  arrow;

    public RunArrow(MainGui gui, Arw arrow) {
        this.gui = gui;
        this.arrow = arrow;

    }

    public void run() {
        try {
            arrow.execute();
        } catch (ExecutionError | ConformanceError e) {
            gui.postCatLiteMsg(e.getMessage());
            gui.postCatLiteMsg("no further execution allowed until new path is entered");
            gui.blockFurtherExecution = true;
            return;
        }
        gui.executionFinished = true;
        gui.postCatLiteMsg("execution of " + arrow.name() + " is done");
    }

}
