/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pathexpression;

import CatCore.Domains.Domain;
import org.junit.Before;
import org.junit.Test;

/**
 *
 * @author dsb
 */
public class DomainTest {
    
    public DomainTest() {
    }
    
    @Before
    public void setUp() {
        Domain.init();
    }

    @Test
    public void test1() {
        Domain a,b,c;
        a = new Domain("d1","e1");
        b = new Domain("d2","e2");
        assert(a.dom().equals("d1"));
        assert(b.dom().equals("d2"));
        assert(a.ext().equals("e1"));
        assert(b.ext().equals("e2"));
    }
    
    @Test
    public void test2() {
        Domain a,b,c;
        a = new Domain("d1","e1");
        b = new Domain("d2","e2");
        assert(!a.dom().equals("d11"));
        assert(!b.dom().equals("d21"));
        assert(!a.ext().equals("e11"));
        assert(!b.ext().equals("e21"));
    }
    
    @Test
    public void test3() {
        Domain a,b,c;
        a = new Domain("d1","e1");
        b = Domain.makeReplica("d1_3");
        assert(b.dom().equals("d1_3"));
        assert(b.ext().equals("e1"));
    }
    
    @Test
    public void test4() {
        Domain b;
        try {
        b = Domain.makeReplica("d1_3");
        } 
        catch(RuntimeException e) {
            String m = e.getMessage();
            assert (m.startsWith("C12: replica domain has no base"));
            return;
        }
        assert(false);
    }
    
    @Test
    public void test5() {
        Domain b;
        try {
        b = Domain.makeReplica("d1");
        } 
        catch(RuntimeException e) {
            String m = e.getMessage();
            assert (m.startsWith("C12: replica domain has no '_'" ));
            return;
        }
        assert(false);
    }
}