/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package pathexpression;

import CatCore.Arrows.ArrowPath;
import CatCore.ExecutionError;
import org.junit.Test;

/**
 *
 * @author dsb
 */
public class PathParseTest {

    public PathParseTest() {
    }

    void Succeed(String p) {
        ArrowPath pth = ArrowPath.make(p);
        String ps = pth.toString().replace(" ", "");
        String pp = p.replace(" ", "");
        assert (ps.equals(pp));
    }

    void Fail(String p, String e) {
        try {
            ArrowPath pth = ArrowPath.make(p);
        } catch (ExecutionError er) {
            String msg = er.getMessage();
            assert (msg.startsWith(e));
            return;
        }
        assert (false);  // automatic fail
    }

    /**
     * Test of toString method, of class ArrowPath.
     */
    @Test
    public void t1() {
        Succeed("p1 = a1. a2.dom_1.dom_3.a3;");
    }

    @Test
    public void t2() {
        Fail("p1 =  = a1. a2.dom_1.dom_3.a3;", "C12: illegal path declaration:");
    }

    @Test
    public void t3() {
        Fail("p1  a1. a2.dom_1.dom_3.a3;", "C12: illegal path declaration:");
    }

    @Test
    public void t4() {
        Fail("p1 = a1. a2.dom_1.dom_3.a3", "C12: path does not end in");
    }

    @Test
    public void t5() {
        Fail("p1 = a1. a2..dom_1.dom_3.a3;", "C12: empty .. path in");
    }

    @Test
    public void t6() {
        Fail("p1 = ;", "C12: empty .. path in");
    }

    @Test
    public void t7() {
        Fail("p1 = ", "C12: path does not end in");
    }
}