package CVParser;

import CVParser.importer.Importer;

public class Main {
    static String inputFile;

    /**
     * Main
     */
    public static void main(String... args) {
        
        // Standard marquee test
        if (args.length != 2) {
            System.out.println("Usage: DecentClassVioletParser.Main <in>.violet <out>.pl");
        }
        inputFile = args[0];   

        //Import XML data into Java objects
        Importer importer = new Importer(inputFile);
        importer.importNodesAndEdges();
        importer.assignParents();

        //Write our Violet DB file
        DBWriter dbWriter = new DBWriter(args[1], importer.getClassNodes(), importer.getClassEdges(),
                importer.getClassInterfaces(), importer.getVioletData(), importer.getNumNodes());
        dbWriter.generateVioletDB();

        //Write our Standard DB file
        //SDBWriter sdbWriter = new SDBWriter(inputFile+DBWriter.DB_FILE_APPENSION);
        //sdbWriter.generateVioletSDB();

        //Convert Violet DB file back to Violet XML
        //String convertedFile = generateVioletXML();

        //Diff Original Violet XML with Converted (back) Violet XML
        //validator.Validator.main(new String[]{inputFile, convertedFile});
    }
}
