package CVParser.importer;

public class ClassEdge {

    private String classType = "";
    private String bentStyle = "";
    private String endArrowHead = "";
    private String startArrowHead = "";
    private String startsAtClass = "";
    private String endsAtClass = "";
    private String startLabel = "";
    private String endLabel = "";
    private String middleLabel = "";
    private String lineStyle = "";
    private String startsType = "";
    private String endsType = "";

    public ClassEdge(String classType) {
        this.classType = classType;
    }

    public void setStartsType(String type1) {
        this.startsType = type1;
    }

    public void setEndsType(String type2) {
        this.endsType = type2;
    }

    public String getStartsType() {
        return this.startsType;
    }

    public String getEndsType() {
        return this.endsType;
    }

    public void setLineStyle(String lineStyle) {
        this.lineStyle = lineStyle;
    }

    public String getLineStyle() {
        return this.lineStyle;
    }

    public void setBentStyle(String bentStyle) {
        this.bentStyle = bentStyle;
    }

    public void setEndLabel(String endLabel) {
        this.endLabel = endLabel.toLowerCase();
    }

    public void setStartLabel(String startLabel) {
        this.startLabel = startLabel.toLowerCase();
    }

    public void setMiddleLabel(String middleLabel) {
        this.middleLabel = middleLabel.toLowerCase();
    }
    
    public void setStartArrowHead(String startArrowHead) {
        this.startArrowHead = startArrowHead;
    }

    public void setEndArrowHead(String endArrowHead) {
        this.endArrowHead = endArrowHead;
    }

    public void setStartsAtClass(String startsAtClass) {
        this.startsAtClass = startsAtClass;
    }

    public void setEndsAtClass(String endsAtClass) {
        this.endsAtClass = endsAtClass;
    }

    public String getStartLabel() {
        return returnNoNull(startLabel);
    }

    public String getEndLabel() {
        return returnNoNull(endLabel);
    }
    
    public String getMiddleLabel() {
        return returnNoNull(middleLabel);
    }

    public String getStartArrowHead() {
        return startArrowHead;
    }

    public String getEndArrowHead() {
        return endArrowHead;
    }

    public String getBentStyle() {
        return bentStyle;
    }

    public String getStartsAtClass() {
        return startsAtClass;
    }

    public String getEndsAtClass() {
        return endsAtClass;
    }

    @Override
    public String toString() {
        String str = "";
        str += "BentStyle: " + bentStyle
                + ", LineStyle: " + lineStyle
                + ", StartArrowHead: " + startArrowHead
                + ", EndArrowHead: " + endArrowHead
                + ", StartLabel: " + startLabel
                + ", EndLabel: " + endLabel
                + ", ClassType: " + classType
                + ", From: " + startsAtClass
                + ", To: " + endsAtClass
                + ", From Type: " + startsType
                + ", To Type: " + endsType;

        return str;
    }
    
    String returnNoNull(String x) {
        if (x==null)
            return "";
        else
            return x;
    }
}
