/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CatLite;

import CatCore.AdviceUtilities;
import CatCore.CTO;
import CatCore.ExeMethods;
import CatCore.ExecutionError;
import CatCore.ReadPrologDatabase;
import CatCore.Var;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Map;

/**
 *
 * @author dsb
 */
public class Advice extends AdviceUtilities {

    // this program is written for dummies (like myself) who need help
    // to create a CatLite metamodel.  There are no arguments to main()
    public static void main(String... args) throws FileNotFoundException {
        ReadPrologDatabase pdb;
        String fileName, newConfigFile, newDir;
        CTO cto;
        
        // Step 1: get the state specification
        if (!isVarPresent("state")) {
            post("use violet to create a state/category diagram and enter \nit" +
                    " into the table as the value for the state domain", "state");
            ExeMethods.silentExe("java","com.horstmann.violet.UMLEditor");
            return;
        }

        // Step 2: violet file exists.  has it been parsed?
        // if a .lite.pl file exists, then something has happened.
        if (!isVarPresent("lite")) {
            if (executeArrowByName("parse", "fix the errors in your category diagram","state")) {
                return;
            }
        }

        // Step 3: at this point, we have successfully compiled a category diagram
        // now we need to read in the .lite.pl file to see what else needs to be done
        cto = Var.get("lite");
        fileName = cto.fullName();
        File lite = cto.toFile();
        try {
            PrintStream eps = new PrintStream(CatCore.Main.errorMsgFile());
            pdb = new ReadPrologDatabase(lite, eps);
        } catch (FileNotFoundException e) {
            post("could not read " + fileName, null);
            return;
        }

        for (Map<String, String> tuple : pdb.tables.get("domainS")) {
            String domain = tuple.get("name");
            String ext = tuple.get("ext");
            if (ext.equals("pl")) {
                File d = getLocalFile(domain, ".class.violet");
                if (!d.exists()) {
                    post("now create a violet class diagram file for domain " + domain, "class");
                    ExeMethods.silentExe("java","com.horstmann.violet.UMLEditor");
                    return;
                }
                // if we get here, the file exists -- compile it and proceed
                // only if there are no errors
                String violetFileName = CatCore.Main.normalizePath(CatCore.Main.GetAbsolutePath(d));
                Var.put(violetFileName);
                if (executeArrowByName("class2vpl","fix the errors in " + domain + ".class.violet","class")) {
                    return;
                }

                // OK this file compiles.  Now create its schema
                if (executeArrowByName("makeSchema","report error in makeSchema mapping","schema"))
                    return;
            }
        }
        
        // Step 4: if we get to this point, we have created schemas for all files.  
        // let's put it all together now
        if (executeArrowByName("construct","this shouldn't happen! -- check prior error messages",null)) {
            return;
        }
//        Properties props = CatCore.Main.cloneConfigFile();
//        props.setProperty("METAMODEL_PATH", CatCore.Main.CURRENT_DIRECTORY + cto.shortName());
//        props.setProperty("ADVICE", "");
//        props.setProperty("MY_HOME", cto.shortName());
//        props.setProperty("CURRENT_DIRECTORY", CatCore.Main.CURRENT_DIRECTORY + cto.shortName());

        newDir = CatCore.Main.CURRENT_DIRECTORY + cto.shortName();
        newConfigFile = newDir + "/config.properties";
        try {
            PrintStream out = new PrintStream(newConfigFile);
            DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
            Date date = new Date();
            out.println(dateFormat.format(date));
            out.format("METAMODEL_PATH=%s\n",newDir );
            out.format("MY_HOME=%s\n",cto.shortName());
            out.format("ADVICE=null");
        }
//        newConfigFile = CatCore.Main.normalizePath(CatCore.Main.CURRENT_DIRECTORY + cto.shortName() +"/config.properties");
//        try {
//            FileOutputStream here = new FileOutputStream( newConfigFile );
//            props.store(here, "copied from parent directory");
//        }
        catch (FileNotFoundException xxx) {
            System.err.println("cannot write "+ newConfigFile);
            throw new ExecutionError("cannot write "+ newConfigFile);
        }
       
        post("Done! You are ready to bootstrap.\nEnter directory "+ cto.shortName() + " and run CatCore.Gui.",null); //" + cto.shortName() + "
    }
}
